/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;
import android.app.SearchManager;
import android.content.ContentProvider;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Intent;
import android.content.UriMatcher;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.text.TextUtils;
import android.util.Log;
import net.micode.notes.R;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
// 定义一个NotesProvider类，继承自ContentProvider类
public class NotesProvider extends ContentProvider {
 // 定义一个UriMatcher对象
    private static final UriMatcher mMatcher;
 // 声明一个NotesDatabaseHelper对象
    private NotesDatabaseHelper mHelper;
 // 定义一个常量，用于标识NotesProvider
    private static final String TAG = "NotesProvider";
 // 定义URI常量
    private static final int URI_NOTE            = 1; // 笔记URI
    private static final int URI_NOTE_ITEM       = 2; // 笔记项URI
    private static final int URI_DATA            = 3; // 数据URI
    private static final int URI_DATA_ITEM       = 4; // 数据项URI

// 定义URI_SEARCH常量，值为5
    private static final int URI_SEARCH          = 5;
// 定义URI_SEARCH_SUGGEST常量，值为6
    private static final int URI_SEARCH_SUGGEST  = 6;

    static {
// 创建一个UriMatcher对象，用于匹配Uri
        mMatcher = new UriMatcher(UriMatcher.NO_MATCH);
// 添加匹配规则，匹配"note"路径，返回URI_NOTE
        mMatcher.addURI(Notes.AUTHORITY, "note", URI_NOTE);
// 添加匹配规则，匹配"note/#"路径，返回URI_NOTE_ITEM
        mMatcher.addURI(Notes.AUTHORITY, "note/#", URI_NOTE_ITEM);
// 添加匹配规则，匹配"data"路径，返回URI_DATA
        mMatcher.addURI(Notes.AUTHORITY, "data", URI_DATA);
// 添加匹配规则，匹配"data/#"路径，返回URI_DATA_ITEM
        mMatcher.addURI(Notes.AUTHORITY, "data/#", URI_DATA_ITEM);
// 添加匹配规则，匹配"search"路径，返回URI_SEARCH
        mMatcher.addURI(Notes.AUTHORITY, "search", URI_SEARCH);
// 添加匹配规则，匹配"search/*"路径，返回URI_SEARCH_SUGGEST
        mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY, URI_SEARCH_SUGGEST);
// 添加匹配规则，匹配"search/*"路径，返回URI_SEARCH_SUGGEST
        mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY + "/*", URI_SEARCH_SUGGEST);
    }

   
 // 定义一个常量，用于搜索笔记的投影
    private static final String NOTES_SEARCH_PROJECTION = NoteColumns.ID + ","
        + NoteColumns.ID + " AS " + SearchManager.SUGGEST_COLUMN_INTENT_EXTRA_DATA + ","
        // 将NoteColumns.SNIPPET中的换行符替换为空字符串，并去除首尾空格，作为SearchManager.SUGGEST_COLUMN_TEXT_1的值
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_1 + ","
        // 将NoteColumns.SNIPPET中的换行符替换为空字符串，并去除首尾空格，作为SearchManager.SUGGEST_COLUMN_TEXT_2的值
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_2 + ","
        // 将R.drawable.search_result作为SearchManager.SUGGEST_COLUMN_ICON_1的值
        + R.drawable.search_result + " AS " + SearchManager.SUGGEST_COLUMN_ICON_1 + ","
        // 将Intent.ACTION_VIEW作为SearchManager.SUGGEST_COLUMN_INTENT_ACTION的值
        + "'" + Intent.ACTION_VIEW + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_ACTION + ","
        // 将Notes.TextNote.CONTENT_TYPE作为SearchManager.SUGGEST_COLUMN_INTENT_DATA的值
        + "'" + Notes.TextNote.CONTENT_TYPE + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_DATA;

 // 定义一个静态字符串变量，用于存储查询语句
    private static String NOTES_SNIPPET_SEARCH_QUERY = "SELECT " + NOTES_SEARCH_PROJECTION
// 拼接SQL语句，查询note表中snippet字段包含指定字符串，且parent_id不等于ID_TRASH_FOLER，且type等于TYPE_NOTE的记录
        + " FROM " + TABLE.NOTE // 添加查询表名
        + " WHERE " + NoteColumns.SNIPPET + " LIKE ?" // 添加查询条件，匹配片段
        + " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER // 添加查询条件，排除回收站
        + " AND " + NoteColumns.TYPE + "=" + Notes.TYPE_NOTE; // 添加查询条件，匹配笔记类型

    @Override
    // 重写onCreate方法
    public boolean onCreate() {
        // 获取NotesDatabaseHelper实例
 // 获取NotesDatabaseHelper的实例
        mHelper = NotesDatabaseHelper.getInstance(getContext());
 // 返回true
        return true;
    }

    @Override
    // 重写query方法，用于查询数据
// 根据给定的Uri、投影、选择条件和排序顺序查询数据
    public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs,
            String sortOrder) {
// 声明一个游标变量
        Cursor c = null;
// 获取一个只读的数据库对象
        SQLiteDatabase db = mHelper.getReadableDatabase();
// 声明一个字符串类型的变量id，并初始化为null
        String id = null;
// 根据传入的uri，匹配对应的URI_NOTE，然后执行相应的操作
        switch (mMatcher.match(uri)) {
    // 如果匹配到URI_NOTE，则执行以下操作
            case URI_NOTE:
        // 查询数据库，获取指定表中的数据
// 查询数据库中的NOTE表，返回指定列的数据
                c = db.query(TABLE.NOTE, projection, selection, selectionArgs, null, null,
                        sortOrder);
// 根据selection和selectionArgs进行筛选，返回结果集
                break;
// 根据URI_NOTE_ITEM的值，获取路径中的第二个参数作为id
            case URI_NOTE_ITEM:
                id = uri.getPathSegments().get(1);
// 使用id作为查询条件，查询数据库中的NOTE表，返回结果集
                c = db.query(TABLE.NOTE, projection, NoteColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs, null, null, sortOrder);
                break;
// 处理URI_DATA
            case URI_DATA:
 // 从数据库中查询数据，返回一个Cursor对象
                c = db.query(TABLE.DATA, projection, selection, selectionArgs, null, null,
                        sortOrder);
                break;
// 根据URI_DATA_ITEM的值，获取路径中的第二个参数作为id
            case URI_DATA_ITEM:
                id = uri.getPathSegments().get(1);
// 查询数据库，获取指定id的数据，projection为查询的列，selection为查询的条件，selectionArgs为查询条件的参数
                c = db.query(TABLE.DATA, projection, DataColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs, null, null, sortOrder);
                break;
            case URI_SEARCH:
            case URI_SEARCH_SUGGEST:
                if (sortOrder != null || projection != null) {
                    throw new IllegalArgumentException(
                            "do not specify sortOrder, selection, selectionArgs, or projection" + "with this query");
                }

                String searchString = null;
                if (mMatcher.match(uri) == URI_SEARCH_SUGGEST) {
                    if (uri.getPathSegments().size() > 1) {
                        searchString = uri.getPathSegments().get(1);
                    }
                } else {
                    searchString = uri.getQueryParameter("pattern");
                }

                if (TextUtils.isEmpty(searchString)) {
                    return null;
                }

                try {
                    searchString = String.format("%%%s%%", searchString);
                    c = db.rawQuery(NOTES_SNIPPET_SEARCH_QUERY,
                            new String[] { searchString });
                } catch (IllegalStateException ex) {
                    Log.e(TAG, "got exception: " + ex.toString());
                }
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);
        }
        if (c != null) {
            c.setNotificationUri(getContext().getContentResolver(), uri);
        }
        return c;
    }

    @Override
    public Uri insert(Uri uri, ContentValues values) {
        SQLiteDatabase db = mHelper.getWritableDatabase();
        long dataId = 0, noteId = 0, insertedId = 0;
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                insertedId = noteId = db.insert(TABLE.NOTE, null, values);
                break;
            case URI_DATA:
                if (values.containsKey(DataColumns.NOTE_ID)) {
                    noteId = values.getAsLong(DataColumns.NOTE_ID);
                } else {
                    Log.d(TAG, "Wrong data format without note id:" + values.toString());
                }
                insertedId = dataId = db.insert(TABLE.DATA, null, values);
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);
        }
        
        if (noteId > 0) {
            getContext().getContentResolver().notifyChange(
                    ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), null);
        }

        
        if (dataId > 0) {
            getContext().getContentResolver().notifyChange(
                    ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId), null);
        }

        return ContentUris.withAppendedId(uri, insertedId);
    }

    @Override
    public int delete(Uri uri, String selection, String[] selectionArgs) {
        int count = 0;
        String id = null;
        SQLiteDatabase db = mHelper.getWritableDatabase();
        boolean deleteData = false;
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                selection = "(" + selection + ") AND " + NoteColumns.ID + ">0 ";
                count = db.delete(TABLE.NOTE, selection, selectionArgs);
                break;
            case URI_NOTE_ITEM:
                id = uri.getPathSegments().get(1);
                
                long noteId = Long.valueOf(id);
                if (noteId <= 0) {
                    break;
                }
                count = db.delete(TABLE.NOTE,
                        NoteColumns.ID + "=" + id + parseSelection(selection), selectionArgs);
                break;
            case URI_DATA:
                count = db.delete(TABLE.DATA, selection, selectionArgs);
                deleteData = true;
                break;
            case URI_DATA_ITEM:
                id = uri.getPathSegments().get(1);
                count = db.delete(TABLE.DATA,
                        DataColumns.ID + "=" + id + parseSelection(selection), selectionArgs);
                deleteData = true;
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);
        }
        if (count > 0) {
            if (deleteData) {
                getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);
            }
            getContext().getContentResolver().notifyChange(uri, null);
        }
        return count;
    }

    @Override
    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
        int count = 0;
        String id = null;
        SQLiteDatabase db = mHelper.getWritableDatabase();
        boolean updateData = false;
        switch (mMatcher.match(uri)) {
            case URI_NOTE:
                increaseNoteVersion(-1, selection, selectionArgs);
                count = db.update(TABLE.NOTE, values, selection, selectionArgs);
                break;
            case URI_NOTE_ITEM:
                id = uri.getPathSegments().get(1);
                increaseNoteVersion(Long.valueOf(id), selection, selectionArgs);
                count = db.update(TABLE.NOTE, values, NoteColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs);
                break;
            case URI_DATA:
                count = db.update(TABLE.DATA, values, selection, selectionArgs);
                updateData = true;
                break;
            case URI_DATA_ITEM:
                id = uri.getPathSegments().get(1);
                count = db.update(TABLE.DATA, values, DataColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs);
                updateData = true;
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);
        }

        if (count > 0) {
            if (updateData) {
                getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);
            }
            getContext().getContentResolver().notifyChange(uri, null);
        }
        return count;
    }

    private String parseSelection(String selection) {
        return (!TextUtils.isEmpty(selection) ? " AND (" + selection + ')' : "");
    }

    private void increaseNoteVersion(long id, String selection, String[] selectionArgs) {
        StringBuilder sql = new StringBuilder(120);
        sql.append("UPDATE ");
        sql.append(TABLE.NOTE);
        sql.append(" SET ");
        sql.append(NoteColumns.VERSION);
        sql.append("=" + NoteColumns.VERSION + "+1 ");

        if (id > 0 || !TextUtils.isEmpty(selection)) {
            sql.append(" WHERE ");
        }
        if (id > 0) {
            sql.append(NoteColumns.ID + "=" + String.valueOf(id));
        }
        if (!TextUtils.isEmpty(selection)) {
            String selectString = id > 0 ? parseSelection(selection) : selection;
            for (String args : selectionArgs) {
                selectString = selectString.replaceFirst("\\?", args);
            }
            sql.append(selectString);
        }

        mHelper.getWritableDatabase().execSQL(sql.toString());
    }

    @Override
    public String getType(Uri uri) {
       
        return null;
    }

}
